---
title: "FreeBSD/amd64 6.1-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005, 2006 The
FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: src/release/doc/en_US.ISO8859-1/relnotes/common/new.sgml,v
1.883.2.15.2.7 2006/05/05 17:07:14 hrs Exp $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN24" name="AEN24"></a>
<p>The release notes for FreeBSD 6.1-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 6.1-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>

<dt>2.2.6 <a href="#AEN392">Contributed Software</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#AEN580">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>

<dt>2.7 <a href="#DOC">Documentation</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 6.1-RELEASE on the AMD64 hardware
platform. It describes recently added, changed, or deleted features of FreeBSD. It also
provides some notes on upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 6.1-RELEASE is a snapshot distribution. It can be found
at <a href="http://www.FreeBSD.org/snapshots/"
target="_top">http://www.FreeBSD.org/snapshots/</a> or any of its mirrors. More
information on obtaining this (or other) snapshot distributions of FreeBSD can be found
in the <a href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 6.1-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
6.0-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
6.0-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>A temporary file vulnerability in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=texindex&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">texindex</span>(1)</span></a>,
which could allow a local attacker to overwrite files in the context of a user running
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=texindex&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">texindex</span>(1)</span></a>
utility, has been fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:01.texindex.asc"
target="_top">FreeBSD-SA-06:01.texindex</a>.</p>

<p>A temporary file vulnerability in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ee&sektion=1&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ee</span>(1)</span></a> text editor,
which could allow a local attacker to overwrite files in the context of a user running <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ee&sektion=1&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ee</span>(1)</span></a>, has been
fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:02.ee.asc"
target="_top">FreeBSD-SA-06:02.ee</a>.</p>

<p>Several vulnerabilities in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpio&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpio</span>(1)</span></a> utility
have been corrected. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:03.cpio.asc"
target="_top">FreeBSD-SA-06:03.cpio</a>.</p>

<p>An error in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> IP
fragment handling, which could cause a crash, has been fixed. For more details see
security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:04.ipfw.asc"
target="_top">FreeBSD-SA-06:04.ipfw</a>.</p>

<p>A potential buffer overflow in the IEEE 802.11 scanning code has been corrected. For
more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:05.80211.asc"
target="_top">FreeBSD-SA-06:05.80211</a>.</p>

<p>Two instances in which portions of kernel memory could be disclosed to users have been
fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:06.kmem.asc"
target="_top">FreeBSD-SA-06:06.kmem</a>.</p>

<p>A logic bug in the IP fragment handling in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pf&sektion=4&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">pf</span>(4)</span></a>, which could
cause a crash under certain circumstances, has been fixed. For more details see security
advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:07.pf.asc"
target="_top">FreeBSD-SA-06:07.pf</a>.</p>

<p>A logic bug in the NFS server code, which could cause a crash when the server received
a message with a zero-length payload, has been fixed. For more details see security
advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:10.nfs.asc"
target="_top">FreeBSD-SA-06:10.nfs</a>.</p>

<p>A programming error in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fast_ipsec&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fast_ipsec</span>(4)</span></a>
implementation results in the sequence number associated with a Security Association not
being updated, allowing packets to unconditionally pass sequence number verification
checks, has been fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:11.ipsec.asc"
target="_top">FreeBSD-SA-06:11.ipsec</a>.</p>

<p>A logic bug that could cause <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=opiepasswd&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">opiepasswd</span>(1)</span></a> to
allow an unprivileged user to configure OPIE authentication for the root user under
certain circumstances, has been fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:12.opie.asc"
target="_top">FreeBSD-SA-06:12.opie</a>.</p>

<p>An asynchronous signal handling vulnerability in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sendmail&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sendmail</span>(8)</span></a>,
which could allow a remote attacker to execute arbitrary code with the privileges of the
user running sendmail, typically <tt class="USERNAME">root</tt>, has been fixed. For more
details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:13.sendmail.asc"
target="_top">FreeBSD-SA-06:13.sendmail</a>.</p>

<p>An information disclosure issue found in the FreeBSD kernel running on 7th- and
8th-generation AMD processors has been fixed. For more details see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-06:14.fpu.asc"
target="_top">FreeBSD-SA-06:14.fpu</a>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> debugger
now supports the <tt class="LITERAL">show lock</tt> command. If the argument has a valid
lock class, this displays various information about the lock and calls a new function
pointer in lock_class (lc_ddb_show) to dump class-specific information about the lock as
well (such as the owner of a mutex or xlock'ed sx lock).</p>

<p><tt class="FILENAME">DEFAULTS</tt> kernel configuration files for each platform have
been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=firmware&sektion=9&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">firmware</span>(9)</span></a>
subsystem has been added. This allows to load binary data into the kernel via a specially
crafted module.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=random&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">random</span>(4)</span></a>
entropy device driver is now MPSAFE.</p>

<p>A new sysctl variable <code class="VARNAME">security.mac.biba.interfaces_equal</code>
which makes all network interfaces be created with the label <tt
class="LITERAL">biba/equal(equal-equal)</tt>, has been added. This is useful where
programs such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a>. which
initialize network interfaces do not have any labeling support. This variable is set as
<tt class="LITERAL">0</tt>(disabled) by default.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>A new loader tunable <code class="VARNAME">comconsole_speed</code> to change the
serial console speed has been added. If the previous stage boot loader requested a serial
console then the default speed is determined from the current serial port speed, and
otherwise it is set to 9600 or the value of the kernel option <tt
class="LITERAL">BOOT_COMCONSOLE_SPEED</tt> at compile time.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_thermal&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_thermal</span>(4)</span></a>
driver now supports passive cooling.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> driver
has been integrated into <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syscons&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syscons</span>(4)</span></a> and
the <tt class="DEVICENAME">kbd</tt> device driver. By default <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syscons&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syscons</span>(4)</span></a> will
look for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a>
keyboard first, and then, if not found, look for any keyboard. Switching to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> can be
done at boot time by loading the <tt class="LITERAL">kbdmux</tt> kernel module via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>, or at
runtime via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kldload&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kldload</span>(8)</span></a> and
releasing the active keyboard.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=agp&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">agp</span>(4)</span></a> driver
now supports ATI IGP chipsets.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sound&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sound</span>(4)</span></a> driver
has been updated in various aspects including fixing lock-related bugs that could cause
system panics in the previous releases and some performance improvements. Also this
driver now supports wider range sampling rate, multiple precisions choice, and 24/32-bit
PCM format conversion.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_atiixp&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_atiixp</span>(4)</span></a>
driver has been added. This supports ATI IXP 200/300/400 series audio controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_als4000&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_als4000</span>(4)</span></a>
driver is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_es137x&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_es137x</span>(4)</span></a>
driver is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_ich&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_ich</span>(4)</span></a>
driver is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_solo&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_solo</span>(4)</span></a>
driver is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=speaker&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">speaker</span>(4)</span></a>
driver now supports FreeBSD/amd64.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_via8233&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_via8233</span>(4)</span></a>
driver is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_via82c686&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_via82c686</span>(4)</span></a>
driver is now MPSAFE.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a> driver
has been updated to version 0.9.16.16.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> driver,
which supports Broadcom NetXtreme II (BCM5706/BCM5708) PCI/PCIe Gigabit Ethernet
controllers, has been added. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a>.</p>

<p>A bug which prevents the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bfe&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bfe</span>(4)</span></a> driver
from working on a system with over 1GB RAM has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=polling&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">polling</span>(4)</span></a>
mode.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver now
supports big-endian architectures such as sparc64.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=le&sektion=4&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">le</span>(4)</span></a> driver, which
supports AMD Am7900 LANCE and Am79C9xx PCnet NICs and is based on NetBSD's
implementation, has been added. While the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lnc&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lnc</span>(4)</span></a> driver
also supports these NICs, this driver has several advantages over it such as MPSAFE,
ALTQ, VLAN_MTU, ifmedia, and 32-bit DMA for PCI variants.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lge&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lge</span>(4)</span></a> driver is
now MPSAFE.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a>
retransmission algorithm has been rewritten as that ARP requests are retransmitted
without suppression, while there is demand for such ARP entry. Due to this change, a
sysctl variable <code class="VARNAME">net.link.ether.inet.host_down_time</code> has been
removed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a> now
supports a sysctl variable <code
class="VARNAME">net.link.ether.inet.log_arp_permanent_modify</code> to suppress logging
of attempts to modify permanent ARP entries.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a>
bridge driver now supports creating span ports, which transmit a copy of every frame
received by the bridge. This feature can be enabled by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a>
bridge driver now supports RFC 3378 EtherIP. This change makes it possible to add <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a>
interfaces to bridges, which will then send and receive IP protocol 97 packets. Packets
are Ethernet frames with an EtherIP header prepended.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> IP
packet filter now supports IPv6. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6fw&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip6fw</span>(8)</span></a> packet
filter is deprecated and will be removed in the future releases.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> now
supports substitution of the action argument with the value obtained from table lookup,
which allows some optimization of rulesets. This is now applicable only to <tt
class="LITERAL">pipe</tt>, <tt class="LITERAL">queue</tt>, <tt
class="LITERAL">divert</tt>, <tt class="LITERAL">tee</tt>, <tt
class="LITERAL">netgraph</tt>, and <tt class="LITERAL">ngtee</tt> rules. For example, the
following rules will throw different packets to different pipes:</p>

<pre class="PROGRAMLISTING">
pipe 1000 config bw 1000Kbyte/s
pipe 4000 config bw 4000Kbyte/s
table 1 add x.x.x.x 1000
table 1 add x.x.x.y 4000
pipe tablearg ip from table(1) to any
</pre>

<p>A bug has been fixed in which NFS over TCP would not reconnect when the server sent a
FIN. This problem had occurred with Solaris NFS servers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_iface&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_iface</span>(4)</span></a>
Netgraph node now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>.</p>

<p>The path MTU discovery for multicast packets in the FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip6</span>(4)</span></a> stack has
been disabled by default because notifying path MTU by a lot of routers in multicast can
be a kind of distributed Denial-of-Service attack to a router. This feature can be
re-enabled by using a new sysctl variable <code
class="VARNAME">net.inet6.ip6.mcast_pmtu</code>.</p>

<p>The TCP bandwidth-delay product limiting feature has been disabled when the RTT is
below a certain threshold. This optimization does not make sense on a LAN as it has
trouble figuring out the maximal bandwidth due to the coarse tick granularity. A new
sysctl variable <code class="VARNAME">net.inet.tcp.inflight.rttthresh</code> specifies
the threshold in milliseconds below which this feature will disengage. It defaults to
10ms.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amr</span>(4)</span></a> driver
has been improved on its performance and now supports full 64-bit DMA. While this feature
is enabled by default, this can be forced off by setting the <code
class="VARNAME">hw.amr.force_sg32</code> loader tunable for debugging purpose.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amr</span>(4)</span></a> driver
now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ioctl&sektion=2&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ioctl</span>(2)</span></a>
requests necessary for Linux LSI MegaRaid tools on FreeBSD's Linux emulation
environment.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports a workaround for some controllers whose DMA does not work properly in 48bit
mode. For the suspicious controllers the PIO mode will be used for access to over 137GB
areas.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports the ITE IT8211F IDE controller, and Promise PDC40718 and PDC40719 chip found
in Promise Fasttrak TX4300.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports DMA for kernel crash dump and crash dumping to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
device.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
driver now supports JMicron ATA RAID metadata.</p>

<p>The <tt class="LITERAL">GEOM_LABEL</tt> class now supports Ext2FS, NTFS, and
ReiserFS.</p>

<p>The <tt class="LITERAL">GEOM_MIRROR</tt> class now supports kernel crash dump to the
GEOM providers.</p>

<p>The <tt class="LITERAL">GEOM_MIRROR</tt> and <tt class="LITERAL">GEOM_RAID3</tt>
classes now support sysctl variables <code
class="VARNAME">kern.geom.mirror.disconnect_on_failure</code> and <code
class="VARNAME">kern.geom.graid3.disconnect_on_failure</code> to control whether failed
components will be disconnected or not. The default value is <tt class="LITERAL">1</tt>
to preserve the current behavior, and if it is set to <tt class="LITERAL">0</tt> such
components are not disconnected and the kernel will try to still use them (only first
error will be logged). This is helpful for the case of multiple broken components (in
different places), so actually all data is available. The broken components will be
visible in <tt class="COMMAND">gmirror list</tt> or <tt class="COMMAND">graid3 list</tt>
output with flag <tt class="LITERAL">BROKEN</tt>.</p>

<p>The <tt class="LITERAL">GEOM_MIRROR</tt> and <tt class="LITERAL">GEOM_RAID3</tt>
classes now use parallel I/O request for synchronization to improve the performance. New
sysctl variables <code class="VARNAME">kern.geom.mirror.sync_requests</code> and <code
class="VARNAME">kern.geom.raid3.sync_requests</code> define how many parallel I/O
requests should be used. Also, sysctl variables <code
class="VARNAME">kern.geom.mirror.reqs_per_sync</code>, <code
class="VARNAME">kern.geom.mirror.syncs_per_sec</code>, <code
class="VARNAME">kern.geom.raid3.reqs_per_sync</code>, and <code
class="VARNAME">kern.geom.raid3.syncs_per_sec</code> are deprecated and have been
removed.</p>

<p>A new GEOM class <tt class="LITERAL">GEOM_ZERO</tt> has been added. It creates very
huge provider (41PB) <tt class="FILENAME">/dev/gzero</tt> and mainly for performance
testing. On <tt class="LITERAL">BIO_READ</tt> request it zero-fills <code
class="VARNAME">bio_data</code> and on <tt class="LITERAL">BIO_WRITE</tt> it does
nothing.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
has been updated to the 9.3.0.1 release on the 3ware Web site.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geli&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geli</span>(8)</span></a> now
supports loading keyfiles before root file system is mounted. For example, the following
entries can be used in <tt class="FILENAME">/boot/loader.conf</tt> to enable it:</p>

<pre class="PROGRAMLISTING">
geli_da0_keyfile0_load="YES"
geli_da0_keyfile0_type="da0:geli_keyfile0"
geli_da0_keyfile0_name="/boot/keys/da0.key0"
geli_da0_keyfile1_load="YES"
geli_da0_keyfile1_type="da0:geli_keyfile1"
geli_da0_keyfile1_name="/boot/keys/da0.key1"
geli_da0_keyfile2_load="YES"
geli_da0_keyfile2_type="da0:geli_keyfile2"
geli_da0_keyfile2_name="/boot/keys/da0.key2"

geli_da1s3a_keyfile0_load="YES"
geli_da1s3a_keyfile0_type="da1s3a:geli_keyfile0"
geli_da1s3a_keyfile0_name="/boot/keys/da1s3a.key"
</pre>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mfi</span>(4)</span></a> driver,
which supports the LSI MegaRAID SAS controller family, has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rr232x&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rr232x</span>(4)</span></a>
driver, which supports HighPoint's RocketRAID 232x series of RAID controllers, has been
added.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN392" name="AEN392">2.2.6 Contributed Software</a></h4>

<p><b class="APPLICATION">DRM</b> has been updated to a snapshot from DRI CVS as of
20051202.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsnmpd&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsnmpd</span>(1)</span></a>
utility now supports the Host Resources MIB described in RFC 2790.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=config&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">config</span>(8)</span></a>
utility now supports the <tt class="LITERAL">nocpu</tt> directive, which cancels the
effect of a previous <tt class="LITERAL">cpu</tt> directive.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=config&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">config</span>(8)</span></a>
utility now reads <tt class="FILENAME">DEFAULTS</tt> kernel configuration file if it
exists in the current directory before the specified configuration file.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=csh&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">csh</span>(1)</span></a> utility
now supports NLS catalog. Note that this requires installing the <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/shells/tcsh_nls/pkg-descr"><tt
class="FILENAME">shells/tcsh_nls</tt></a> port.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devd</span>(8)</span></a> utility
now supports a <code class="OPTION">-f</code> option to specify a configuration file.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> utility now
supports an <code class="OPTION">-F</code> flag which allows to delete existing empty
directories, when creating symbolic links.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=locate&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">locate</span>(1)</span></a>
utility now supports a <code class="OPTION">-0</code> flag to make this utility
interoperable with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xargs&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">xargs</span>(1)</span></a>'s <code
class="OPTION">-0</code> flag.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ls&sektion=1&manpath=FreeBSD+6.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ls</span>(1)</span></a> utility now
supports an <code class="OPTION">-I</code> flag to disable the automatic <code
class="OPTION">-A</code> flag for the superuser.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ftpd</span>(8)</span></a> utility
now creates a PID file <tt class="FILENAME">/var/run/ftpd.pid</tt> even when no <code
class="OPTION">-p</code> option is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getfacl&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getfacl</span>(1)</span></a>
utility now supports a <code class="OPTION">-q</code> flag to suppress the per-file
header comment listing the file name, owner, and group.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a>
utility now supports commands to rename objects and to move a subdisk from one drive to
another.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> utility
supports a <code class="OPTION">-J <tt class="REPLACEABLE"><i>jid_file</i></tt></code>
option to write out a JidFile, similar to a PidFile, containing the jailid, path,
hostname, IP and the command used to start the jail.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kdump&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kdump</span>(1)</span></a> utility
now supports a <code class="OPTION">-H</code> flag, which causes kdump to print an
additional field holding the threadid.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kdump&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kdump</span>(1)</span></a> program
now supports a <code class="OPTION">-s</code> flag to suppress the display of I/O
data.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
utility now supports an <code class="OPTION">-A</code> option to explicitly specify an
architecture to pass through to the underlying makefiles.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=moused&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">moused</span>(8)</span></a> daemon
now supports an <code class="OPTION">-H</code> flag to enable horizontal virtual
scrolling similar to a <code class="OPTION">-V</code> flag for vertical virtual
scrolling.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility now supports printing <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipsec&sektion=4&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipsec</span>(4)</span></a>
protocol statistics if the kernel was compiled with <tt class="LITERAL">FAST_IPSEC</tt>
rather than the KAME IPSEC stack. Note that the output of <tt class="COMMAND">netstat -s
-p ipsec</tt> differs depending on which stack is compiled into the kernel since they
each keep different statistics.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">periodic</span>(8)</span></a>
daily script now supports display of the status of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gmirror&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gmirror</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=graid3&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">graid3</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gstripe&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gstripe</span>(8)</span></a>, and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gconcat&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gconcat</span>(8)</span></a>
devices. Note that these are disabled by default.</p>

<p>A new function, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pidfile&sektion=3&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pidfile</span>(3)</span></a>,
which provides reliable pidfiles handling, has been implemented in <tt
class="FILENAME">libutil</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rfcomm_sppd&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rfcomm_sppd</span>(1)</span></a>
now supports service name in addition to <code class="OPTION">-c</code> option with
channel number. The supported names are: DUN (Dial-Up Networking), FAX (Fax), LAN (LAN
Access Using PPP), and SP (Serial Port).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snapinfo&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snapinfo</span>(8)</span></a>
utility, which shows snapshot locations on UFS filesystems, has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strtonum&sektion=3&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strtonum</span>(3)</span></a>
library function has been implemented based on OpenBSD's implementation. This is an
improved version of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strtoll&sektion=3&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strtoll</span>(3)</span></a>.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ypwhich&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ypwhich</span>(1)</span></a>
utility which causes the <code class="OPTION">-m</code> option to produce an incorrect
list of available named maps has been fixed.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>The <tt class="FILENAME">bluetooth</tt> script has been added. This script will be
called from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devd</span>(8)</span></a> in
response to device attachment/detachment events and to stop/start particular device
without unplugging it by hand. The configuration parameters are in <tt
class="FILENAME">/etc/defaults/bluetooth.device.conf</tt>, and can be overridden by using
<tt class="FILENAME">/etc/bluetooth/<tt class="REPLACEABLE"><i>$device</i></tt>.conf</tt>
(where <tt class="REPLACEABLE"><i>$device</i></tt> is <tt class="DEVICENAME">ubt0</tt>,
<tt class="DEVICENAME">btcc0</tt>, and so on.) For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bluetooth.conf&sektion=5&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">bluetooth.conf</span>(5)</span></a>.</p>

<p>The <tt class="FILENAME">hcsecd</tt> and <tt class="FILENAME">sdpd</tt> scripts have
been added for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hcsecd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hcsecd</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdpd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdpd</span>(8)</span></a> daemons.
These daemons can run even if no Bluetooth devices are attached to the system, but both
daemons depend on Bluetooth socket layer and thus disabled by default. Bluetooth sockets
layer must be either loaded as a module or compiled into kernel before the daemons can
run.</p>

<p>The <tt class="FILENAME">hostapd</tt> script for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hostapd&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hostapd</span>(8)</span></a> has
been added.</p>

<p>The <tt class="FILENAME">jail</tt> script now supports the <code
class="VARNAME">jail_interface</code> option and the <code class="VARNAME">jail_<tt
class="REPLACEABLE"><i>jid</i></tt>_interface</code> option which create an IP alias on
the given interface.</p>

<p>The <tt class="FILENAME">netif</tt> script now supports <code
class="VARNAME">ipv4_addrs_<tt class="REPLACEABLE"><i>ifn</i></tt></code>, which adds one
or more IPv4 address from a ranged list in CIRD notation. For example:</p>

<pre class="PROGRAMLISTING">
ipv4_addrs_ed0="192.168.0.1/24 192.168.1.1-5/28"
</pre>

<p>The <tt class="FILENAME">ppp-user</tt> script has been renamed to <tt
class="FILENAME">ppp</tt>.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="AEN580" name="AEN580">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">BIND</b> has been updated from 9.3.1 to 9.3.2.</p>

<p><b class="APPLICATION">hostapd</b> has been updated from version 0.3.9 to version
0.4.8.</p>

<p><b class="APPLICATION">GNU Troff</b> has been updated from version 1.19 to version
1.19.2.</p>

<p><b class="APPLICATION">sendmail</b> has been updated from 8.13.4 to 8.13.6.</p>

<p>The timezone database has been updated from the <b class="APPLICATION">tzdata2005l</b>
release to the <b class="APPLICATION">tzdata2005r</b> release.</p>

<p><b class="APPLICATION">WPA Supplicant</b> has been updated from version 0.3.9 to
version 0.4.8.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_add&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_add</span>(1)</span></a>
command now supports an <code class="OPTION">-P</code> flag, which is the same as the
<code class="OPTION">-p</code> flag except that the given prefix is also used recursively
for the dependency packages if any.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_add&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_add</span>(1)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_create</span>(1)</span></a>
utilities now support a <code class="OPTION">-K</code> flag to save packages to the
current directory (or <code class="VARNAME">PKGDIR</code> if defined) by default.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_create</span>(1)</span></a>
program now supports an <code class="OPTION">-x</code> flag to support basic regular
expressions for package name, an <code class="OPTION">-E</code> flag for extended regular
expressions, and a <code class="OPTION">-G</code> for exact matching.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_version&sektion=1&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_version</span>(1)</span></a>
utility now supports an <code class="OPTION">-o</code> flag to show the origin recorded
on package generation instead of the package name, and an <code class="OPTION">-O</code>
flag to list packages whose registered origin is origin only.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portsnap&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portsnap</span>(8)</span></a>
utility (<tt class="FILENAME">sysutils/portsnap</tt>) has been added into the FreeBSD
base system. This is a secure, easy to use, fast, lightweight, and generally good way for
users to keep their ports trees up to date.</p>

<p>A incorrect handling of <code class="VARNAME">HTTP_PROXY_AUTH</code> in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portsnap&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portsnap</span>(8)</span></a>
utility has been fixed.</p>

<p>The startup scripts from the <code class="VARNAME">local_startup</code> directory now
evaluated by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rcorder&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rcorder</span>(8)</span></a> with
scripts in the base system.</p>

<p>The suffix of startup scripts from the Ports Collection has been removed. This means
<tt class="FILENAME">foo.sh</tt> is renamed to <tt class="FILENAME">foo</tt>, and now
scripts whose name is something like <tt class="FILENAME">foo.ORG</tt> will also be
invoked. You are recommended to reinstall packages which install such scripts and remove
extra files in the <code class="VARNAME">local_startup</code> directory.</p>

<p>New <tt class="FILENAME">rc.conf</tt> variables, <code
class="VARNAME">ldconfig_local_dirs</code> and <code
class="VARNAME">ldconfig_local32_dirs</code> have been added. These hold lists of local
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ldconfig&sektion=8&manpath=FreeBSD+6.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ldconfig</span>(8)</span></a>
directories.</p>

<p>The <tt class="COMMAND">@cwd</tt> command in <tt class="FILENAME">pkg-plist</tt> now
allows no directory argument. If no directory argument is given, it will set current
working directory to the first prefix given by the <tt class="COMMAND">@cwd</tt>
command.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>The <tt class="FILENAME">/var/audit</tt> directory and <tt class="LITERAL">audit</tt>
group have been added. These are for the TrustedBSD <b class="APPLICATION">OpenBSM</b>
distribution, which will be imported in the future releases.</p>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated from 2.10.2 to 2.12.3.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde2/pkg-descr"><tt
class="FILENAME">x11/kde2</tt></a>) has been updated from 3.4.2 to 3.5.1.</p>

<p>The supported version of the <b class="APPLICATION">Perl</b> interpreter (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/lang/perl5.8/pkg-descr"><tt
class="FILENAME">lang/perl5.8</tt></a>) has been updated from 5.8.7 to 5.8.8.</p>

<p>The supported version of the <b class="APPLICATION">Xorg</b> windowing system (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/xorg/pkg-descr"><tt
class="FILENAME">x11/xorg</tt></a>) has been updated from 6.8.2 to 6.9.0.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="DOC" name="DOC">2.7 Documentation</a></h3>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>Source upgrades to FreeBSD 6.1-RELEASE are only supported from FreeBSD 5.3-RELEASE or
later. Users of older systems wanting to upgrade 6.1-RELEASE will need to update to
FreeBSD 5.3 or newer first, then to FreeBSD 6.1-RELEASE.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a
href="http://www.FreeBSD.org/snapshots/">http://www.FreeBSD.org/snapshots/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


